import java.io.BufferedWriter;
import java.io.File;
import java.io.FileWriter;
import java.io.IOException;
import java.util.List;

public class Report {
	
	//--------------------------------------
	//Ivars
	
	private String contents;	
	
	//--------------------------------------
	//Constructors	
	
	public Report(String aContents) {
		super();
		this.contents = aContents;
	}
	
	public Report() {
		this("");
	}	
		
	//--------------------------------------
	//Accessing (public protocol)	

	public String getContents() {
		return contents;
	}
	
	@Override
	public String toString() {
		return getContents();
	}

	//--------------------------------------
	// Methods (public protocol)	

	public Report newline() {
		this.contents += newlineString();
		return this;
	}
	
	public Report newline(int count) {
		for (int i = 0; i < count; i++)
			newline();
		return this;
	}	
	
	public Report show(Object o) {
		basicShow(o);
		return this;
	}
	
	public Report showLine(Object o) {
		basicShow(o);
		newline();
		return this;
	}		
	
	public Report showLines(List<?> lines) {
		for (Object each: lines)
			showLine(each);
		return this;
	}		
	
	//--------------------------------------
	//Writing File and Opening in Editor
	
	public void writeAndView(String path) {
		writeFile(path, getContents());
	    try {
			java.awt.Desktop.getDesktop().edit(new File(path));
		} catch (IOException e) {
			e.printStackTrace();
		}
	}
		
	public static void writeFile(String path, String fileContents) {
		try {
			basicWriteFile(path, fileContents);
		} catch (IOException e) {
			e.printStackTrace();
		}
	}
	
	private static void basicWriteFile(String path, String fileContents) throws IOException {
		File f = new File(path);
		BufferedWriter writer = null;
		try {
			writer = new BufferedWriter(new FileWriter(f));
			writer.write(fileContents);
		} catch (IOException e) {
			e.printStackTrace();
		} finally {
			if (writer != null) writer.close();
		}
	}	
	
	//--------------------------------------
	//Private Methods
	
	private void basicShow(Object o) {
		this.contents += o.toString();
	}	
		
	/* newline aka -- "carriage return line feed", "line separator" */
	private static String newlineString() {
		return System.lineSeparator();
	}
	
	//--------------------------------------	
		
}
