import java.io.BufferedWriter;
import java.io.File;
import java.io.FileWriter;
import java.io.IOException;
import java.util.Arrays;
import java.util.List;

public class ReportDemo {
	
	public static void main(String[] args) throws IOException {
		ReportDemo myDemo = new ReportDemo();
		//myDemo.runDemo();
		myDemo.runDemoWithMethodCascading();
	}

	private void runDemo() throws IOException {
		Report farmCommodityReport = new Report();
		farmCommodityReport.showLine("Farm Report");
		farmCommodityReport.newline();
		farmCommodityReport.showLine("Commodities:");
		farmCommodityReport.newline();		
		farmCommodityReport.showLines(commodityNames());
		farmCommodityReport.newline();
		farmCommodityReport.showLine("Trends:");
		farmCommodityReport.newline();		
		farmCommodityReport.showLine("Corn up $0.05");		
		farmCommodityReport.showLine("Soybeans down -$0.20");		
		farmCommodityReport.showLine("Wheat unchanged");
		farmCommodityReport.writeAndView("FarmReport.txt");
	}
	
	private void runDemoWithMethodCascading() throws IOException {
		Report farmCommodityReport = new Report();
		farmCommodityReport
			.showLine("Farm Report")
			.newline()
			.showLine("Commodities:")
			.newline()		
			.showLines(commodityNames())
			.newline()
			.showLine("Trends:")
			.newline()		
			.showLine("Corn up $0.05")		
			.showLine("Soybeans down -$0.20")		
			.showLine("Wheat unchanged")
			.writeAndView("FarmReport.txt");
	}	
	

	
	//--------------------------------------
	//Helpers
	
	private static List<String> commodityNames() {
		return Arrays.asList("Yellow Corn", "Soybeans", "Wheat");
	}
	

	
	
	
}
